; Copyright (C) 2018-2019 Francis (Fritz) Mahnke.

; This file is part of c64-3d-graphics-series.

; c64-3d-graphics-series is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; c64-3d-graphics-series is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with c64-3d-graphics-series.  If not, see
; <https://www.gnu.org/licenses/>.

    !source "loader.asm"

pen_addr_lo = $2e
pen_addr_hi = $2f
pen_row_loc = $31
pen_pixel_bit = $32
arg0 = $33
arg1 = $34
arg2 = $35
arg3 = $36

    +start_at $0900

    jmp start

    !source "prelude.asm"
    !source "display.asm"

start:
    sei

    ; Put bitmap at 8192

    lda $d018
    ora #$08
    sta $d018

    ; Turn on standard bitmap mode

    lda $d011
    ora #$20
    sta $d011

    ; Set display memory colors to black and cyan.

    +disp_fill $00
    +bitmap_fill $00

    lda #$aa
    sta $2000
    lda #$55
    sta $2001
    lda #$aa
    sta $2008
    lda #$55
    sta $2009
    lda #$aa
    sta $3e06
    lda #$55
    sta $3e07

    lda #$30
    sta $0400
    sta $0401
    sta $0402
    sta $07c0

-   nop
    jmp -
